Index: palm/trunk/SOURCE/diffusion_u.f90
===================================================================
--- palm/trunk/SOURCE/diffusion_u.f90	(revision 56)
+++ palm/trunk/SOURCE/diffusion_u.f90	(revision 57)
@@ -4,5 +4,6 @@
 ! Actual revisions:
 ! -----------------
-! Wall functions now include diabatic conditions, call of routine wall_fluxes
+! Wall functions now include diabatic conditions, call of routine wall_fluxes,
+! z0 removed from argument list
 ! 
 ! Former revisions:
@@ -50,5 +51,5 @@
 ! Call for all grid points
 !------------------------------------------------------------------------------!
-    SUBROUTINE diffusion_u( ddzu, ddzw, km, km_damp_y, tend, u, usws, v, w, z0 )
+    SUBROUTINE diffusion_u( ddzu, ddzw, km, km_damp_y, tend, u, usws, v, w )
 
        USE control_parameters
@@ -61,5 +62,4 @@
        REAL    ::  kmym_x, kmym_y, kmyp_x, kmyp_y, kmzm, kmzp
        REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt+1), km_damp_y(nys-1:nyn+1)
-       REAL    ::  z0(nys-1:nyn+1,nxl-1:nxr+1)
        REAL    ::  tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1)
        REAL, DIMENSION(:,:),   POINTER ::  usws
@@ -207,5 +207,5 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE diffusion_u_ij( i, j, ddzu, ddzw, km, km_damp_y, tend, u, usws, &
-                               v, w, z0 )
+                               v, w )
 
        USE control_parameters
@@ -218,5 +218,4 @@
        REAL    ::  kmym_x, kmym_y, kmyp_x, kmyp_y, kmzm, kmzp
        REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt+1), km_damp_y(nys-1:nyn+1)
-       REAL    ::  z0(nys-1:nyn+1,nxl-1:nxr+1)
        REAL    ::  tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1)
        REAL, DIMENSION(nzb:nzt+1)      ::  usvs
Index: palm/trunk/SOURCE/diffusion_v.f90
===================================================================
--- palm/trunk/SOURCE/diffusion_v.f90	(revision 56)
+++ palm/trunk/SOURCE/diffusion_v.f90	(revision 57)
@@ -4,5 +4,6 @@
 ! Actual revisions:
 ! -----------------
-! Wall functions now include diabatic conditions, call of routine wall_fluxes
+! Wall functions now include diabatic conditions, call of routine wall_fluxes,
+! z0 removed from argument list
 !
 ! Former revisions:
@@ -48,5 +49,5 @@
 ! Call for all grid points
 !------------------------------------------------------------------------------!
-    SUBROUTINE diffusion_v( ddzu, ddzw, km, km_damp_x, tend, u, v, vsws, w, z0 )
+    SUBROUTINE diffusion_v( ddzu, ddzw, km, km_damp_x, tend, u, v, vsws, w )
 
        USE control_parameters
@@ -59,5 +60,4 @@
        REAL    ::  kmxm_x, kmxm_y, kmxp_x, kmxp_y, kmzm, kmzp
        REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt+1), km_damp_x(nxl-1:nxr+1)
-       REAL    ::  z0(nys-1:nyn+1,nxl-1:nxr+1)
        REAL    ::  tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1)
        REAL, DIMENSION(:,:),   POINTER ::  vsws
@@ -205,5 +205,5 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE diffusion_v_ij( i, j, ddzu, ddzw, km, km_damp_x, tend, u, v, &
-                               vsws, w, z0 )
+                               vsws, w )
 
        USE control_parameters
@@ -216,5 +216,4 @@
        REAL    ::  kmxm_x, kmxm_y, kmxp_x, kmxp_y, kmzm, kmzp
        REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt+1), km_damp_x(nxl-1:nxr+1)
-       REAL    ::  z0(nys-1:nyn+1,nxl-1:nxr+1)
        REAL    ::  tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1)
        REAL, DIMENSION(nzb:nzt+1)      ::  vsus
Index: palm/trunk/SOURCE/diffusion_w.f90
===================================================================
--- palm/trunk/SOURCE/diffusion_w.f90	(revision 56)
+++ palm/trunk/SOURCE/diffusion_w.f90	(revision 57)
@@ -4,5 +4,6 @@
 ! Actual revisions:
 ! -----------------
-! Wall functions now include diabatic conditions, call of routine wall_fluxes
+! Wall functions now include diabatic conditions, call of routine wall_fluxes,
+! z0 removed from argument list
 !
 ! Former revisions:
@@ -46,5 +47,5 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE diffusion_w( ddzu, ddzw, km, km_damp_x, km_damp_y, tend, u, v, &
-                            w, z0 )
+                            w )
 
        USE control_parameters
@@ -59,5 +60,4 @@
        REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt+1), km_damp_x(nxl-1:nxr+1), &
                    km_damp_y(nys-1:nyn+1)
-       REAL    ::  z0(nys-1:nyn+1,nxl-1:nxr+1)
        REAL    ::  tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1)
        REAL, DIMENSION(:,:,:), POINTER ::  km, u, v, w
@@ -194,5 +194,5 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE diffusion_w_ij( i, j, ddzu, ddzw, km, km_damp_x, km_damp_y, &
-                               tend, u, v, w, z0 )
+                               tend, u, v, w )
 
        USE control_parameters
@@ -207,5 +207,4 @@
        REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt+1), km_damp_x(nxl-1:nxr+1), &
                    km_damp_y(nys-1:nyn+1)
-       REAL    ::  z0(nys-1:nyn+1,nxl-1:nxr+1)
        REAL    ::  tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1)
        REAL, DIMENSION(nzb:nzt+1)      ::  wsus, wsvs
Index: palm/trunk/SOURCE/diffusivities.f90
===================================================================
--- palm/trunk/SOURCE/diffusivities.f90	(revision 56)
+++ palm/trunk/SOURCE/diffusivities.f90	(revision 57)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! Reference temperature pt_reference can be used in buoyancy term
 ! 
 ! Former revisions:
@@ -90,6 +90,11 @@
              dpt_dz = ( theta(k+1,j,i) - theta(k-1,j,i) ) * dd2zu(k)
              IF ( dpt_dz > 0.0 ) THEN
-                l_stable = 0.76 * sqrt_e(k) / &
-                                  SQRT( g / theta(k,j,i) * dpt_dz ) + 1E-5
+                IF ( use_pt_reference )  THEN
+                   l_stable = 0.76 * sqrt_e(k) / &
+                                     SQRT( g / pt_reference * dpt_dz ) + 1E-5
+                ELSE
+                   l_stable = 0.76 * sqrt_e(k) / &
+                                     SQRT( g / theta(k,j,i) * dpt_dz ) + 1E-5
+                ENDIF
              ELSE
                 l_stable = l_grid(k)
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 56)
+++ palm/trunk/SOURCE/header.f90	(revision 57)
@@ -861,10 +861,11 @@
 !-- Other quantities
     WRITE ( io, 411 )  g
+    IF ( use_pt_reference )  WRITE ( io, 412 )  pt_reference
 
 !
 !-- Cloud physics parameters
     IF ( cloud_physics ) THEN
-       WRITE ( io, 412 )
-       WRITE ( io, 413 ) surface_pressure, r_d, rho_surface, cp, l_v
+       WRITE ( io, 415 )
+       WRITE ( io, 416 ) surface_pressure, r_d, rho_surface, cp, l_v
     ENDIF
 
@@ -1326,7 +1327,8 @@
             '                            f*    = ',F9.6,' 1/s')
 411 FORMAT (/'    Gravity             :   g     = ',F4.1,' m/s**2')
-412 FORMAT (/'    Cloud physics parameters:'/ &
+412 FORMAT (/'    Reference temperature in buoyancy terms: ',F8.4,' K')
+415 FORMAT (/'    Cloud physics parameters:'/ &
              '    ------------------------'/)
-413 FORMAT ('        Surface pressure   :   p_0   = ',F7.2,' hPa'/      &
+416 FORMAT ('        Surface pressure   :   p_0   = ',F7.2,' hPa'/      &
             '        Gas constant       :   R     = ',F5.1,' J/(kg K)'/ &
             '        Density of air     :   rho_0 = ',F5.3,' kg/m**3'/  &
Index: palm/trunk/SOURCE/init_particles.f90
===================================================================
--- palm/trunk/SOURCE/init_particles.f90	(revision 56)
+++ palm/trunk/SOURCE/init_particles.f90	(revision 57)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! displacements for mpi_particle_type changed, age_m initialized
 !
 ! Former revisions:
@@ -61,7 +61,7 @@
     blocklengths(1)  = 18; blocklengths(2)  = 4; blocklengths(3)  =  1
 #if defined( __t3eb )
-    displacements(1) = 0; displacements(2) = 144; displacements(3) = 176
+    displacements(1) = 0; displacements(2) = 152; displacements(3) = 184
 #else
-    displacements(1) = 0; displacements(2) = 144; displacements(3) = 160
+    displacements(1) = 0; displacements(2) = 152; displacements(3) = 168
 #endif
     types(1) = MPI_REAL
@@ -192,5 +192,5 @@
        particles = particle_type( 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, &
                                   0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, &
-                                  0, 0, 0, 0 )
+                                  0.0, 0, 0, 0, 0 )
        particle_groups = particle_groups_type( 0.0, 0.0, 0.0, 0.0 )
 
@@ -267,4 +267,5 @@
                             particles(n)%z             = pos_z
                             particles(n)%age           = 0.0
+                            particles(n)%age_m         = 0.0
                             particles(n)%dt_sum        = 0.0
                             particles(n)%dvrp_psize    = dvrp_psize
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 56)
+++ palm/trunk/SOURCE/modules.f90	(revision 57)
@@ -7,5 +7,6 @@
 ! +array rif_wall
 ! +netcdf_64bit_3d, zu_s_inner, zw_w_inner, id_var_zusi_*, id_var_zwwi_*,
-! ts_value, u_nzb_p1_for_vfc, v_nzb_p1_for_vfc
+! ts_value, u_nzb_p1_for_vfc, v_nzb_p1_for_vfc, pt_reference, use_pt_reference,
+! +age_m in particle_type
 ! -data_output_ts, dots_n
 ! arrays dots_label and dots_unit now dimensioned with dots_max
@@ -296,6 +297,6 @@
                 sloping_surface = .FALSE., stop_dt = .FALSE., &
                 terminate_run = .FALSE., use_prior_plot1d_parameters = .FALSE.,&
-                use_surface_fluxes = .FALSE., use_top_fluxes = .FALSE., &
-                use_ug_for_galilei_tr = .TRUE., &
+                use_pt_reference = .FALSE., use_surface_fluxes = .FALSE., &
+                use_top_fluxes = .FALSE., use_ug_for_galilei_tr = .TRUE., &
                 use_upstream_for_tke = .FALSE., wall_adjustment = .TRUE.
 
@@ -330,10 +331,11 @@
              overshoot_limit_u = 0.0, overshoot_limit_v = 0.0, &
              overshoot_limit_w = 0.0, particle_maximum_age = 9999999.9, &
-             phi = 55.0, prandtl_number = 1.0, pt_slope_offset = 0.0, &
-             pt_surface = 300.0, pt_surface_initial_change = 0.0, &
-             q_surface = 0.0, q_surface_initial_change = 0.0, &
-             rayleigh_damping_factor = -1.0, rayleigh_damping_height = -1.0, &
-             residual_limit = 1.0E-4, restart_time = 9999999.9, rif_max = 1.0, &
-             rif_min = -5.0, roughness_length = 0.1, simulated_time = 0.0, &
+             phi = 55.0, prandtl_number = 1.0, pt_reference = 9999999.9, &
+             pt_slope_offset = 0.0, pt_surface = 300.0, &
+             pt_surface_initial_change = 0.0, q_surface = 0.0, &
+             q_surface_initial_change = 0.0, rayleigh_damping_factor = -1.0, &
+             rayleigh_damping_height = -1.0, residual_limit = 1.0E-4, &
+             restart_time = 9999999.9, rif_max = 1.0, rif_min = -5.0, &
+             roughness_length = 0.1, simulated_time = 0.0, &
              simulated_time_at_begin, sin_alpha_surface, &
              skip_time_data_output = 0.0, skip_time_data_output_av = 9999999.9,&
@@ -828,7 +830,7 @@
     TYPE particle_type
        SEQUENCE
-       REAL    ::  age, dt_sum, dvrp_psize, e_m, origin_x, origin_y, origin_z, &
-                   radius, speed_x, speed_x_sgs, speed_y, speed_y_sgs,         &
-                   speed_z, speed_z_sgs, weight_factor, x, y, z
+       REAL    ::  age, age_m, dt_sum, dvrp_psize, e_m, origin_x, origin_y, &
+                   origin_z, radius, speed_x, speed_x_sgs, speed_y,         &
+                   speed_y_sgs, speed_z, speed_z_sgs, weight_factor, x, y, z
        INTEGER ::  color, group, tailpoints, tail_id
     END TYPE particle_type
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 56)
+++ palm/trunk/SOURCE/palm.f90	(revision 57)
@@ -1,12 +1,8 @@
-#if defined( __vtk )
- SUBROUTINE palm
-#else
  PROGRAM palm
-#endif
 
 !------------------------------------------------------------------------------!
 ! Actual revisions:
 ! -----------------
-! TEST: open(9)
+! __vtk directives removed, open unit 9 for debug output
 !
 ! Former revisions:
@@ -99,4 +95,8 @@
 
 !
+!-- Open a file for debug output
+    OPEN( 9, FILE='DEBUG'//myid_char, FORM='FORMATTED' )
+
+!
 !-- Generate grid parameters
     CALL init_grid
@@ -106,5 +106,4 @@
     CALL check_parameters
 
-    OPEN( 9, FILE='DEBUG'//myid_char, FORM='FORMATTED' )
 !
 !-- Initialize all necessary variables
@@ -169,9 +168,4 @@
 #endif
 
-#if defined( __vtk )
- END SUBROUTINE palm
-#else
  END PROGRAM palm
-#endif
 
-
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 56)
+++ palm/trunk/SOURCE/parin.f90	(revision 57)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! +netcdf_64bit_3d in d3par, -data_output_ts
+! +netcdf_64bit_3d in d3par, +pt_reference in inipar, -data_output_ts
 !
 ! Former revisions:
@@ -65,15 +65,16 @@
                        overshoot_limit_pt, overshoot_limit_u, &
                        overshoot_limit_v, overshoot_limit_w, passive_scalar, &
-                       phi, prandtl_layer, precipitation, pt_surface, &
-                       pt_surface_initial_change, pt_vertical_gradient, &
-                       pt_vertical_gradient_level, q_surface, &
-                       q_surface_initial_change, q_vertical_gradient, &
-                       q_vertical_gradient_level, radiation, random_generator, &
-                       random_heatflux, rif_max, rif_min, roughness_length, &
-                       scalar_advec, statistic_regions, surface_heatflux, &
-                       surface_pressure, surface_scalarflux, surface_waterflux,&
-                       s_surface, s_surface_initial_change, &
-                       s_vertical_gradient, s_vertical_gradient_level, &
-                       top_heatflux, timestep_scheme, topography, ug_surface, &
+                       phi, prandtl_layer, precipitation, pt_reference, &
+                       pt_surface, pt_surface_initial_change, &
+                       pt_vertical_gradient, pt_vertical_gradient_level, &
+                       q_surface, q_surface_initial_change, &
+                       q_vertical_gradient, q_vertical_gradient_level, &
+                       radiation, random_generator, random_heatflux, rif_max, &
+                       rif_min, roughness_length, scalar_advec, &
+                       statistic_regions, surface_heatflux, surface_pressure, &
+                       surface_scalarflux, surface_waterflux, s_surface, &
+                       s_surface_initial_change, s_vertical_gradient, &
+                       s_vertical_gradient_level, top_heatflux, &
+                       timestep_scheme, topography, ug_surface, &
                        ug_vertical_gradient, ug_vertical_gradient_level, &
                        ups_limit_e, ups_limit_pt, ups_limit_u, ups_limit_v, &
Index: palm/trunk/SOURCE/production_e.f90
===================================================================
--- palm/trunk/SOURCE/production_e.f90	(revision 56)
+++ palm/trunk/SOURCE/production_e.f90	(revision 57)
@@ -4,5 +4,6 @@
 ! Actual revisions:
 ! -----------------
-! Wall functions now include diabatic conditions, call of routine wall_fluxes_e
+! Wall functions now include diabatic conditions, call of routine wall_fluxes_e,
+! reference temperature pt_reference can be used in buoyancy term
 !
 ! Former revisions:
@@ -359,22 +360,43 @@
           IF ( .NOT. moisture )  THEN
 
-             DO  j = nys, nyn
-
-                DO  k = nzb_diff_s_inner(j,i), nzt_diff
-                   tend(k,j,i) = tend(k,j,i) - kh(k,j,i) * g / pt(k,j,i) * &
-                                    ( pt(k+1,j,i) - pt(k-1,j,i) ) * dd2zu(k)
+             IF ( use_pt_reference )  THEN
+
+                DO  j = nys, nyn
+                   DO  k = nzb_diff_s_inner(j,i), nzt_diff
+                      tend(k,j,i) = tend(k,j,i) - kh(k,j,i) * g/pt_reference * &
+                                       ( pt(k+1,j,i) - pt(k-1,j,i) ) * dd2zu(k)
+                   ENDDO
+
+                   IF ( use_surface_fluxes )  THEN
+                      k = nzb_diff_s_inner(j,i)-1
+                      tend(k,j,i) = tend(k,j,i) + g / pt_reference * shf(j,i)
+                   ENDIF
+
+                   IF ( use_top_fluxes )  THEN
+                      k = nzt
+                      tend(k,j,i) = tend(k,j,i) + g / pt_reference * tswst(j,i)
+                   ENDIF
                 ENDDO
 
-                IF ( use_surface_fluxes )  THEN
-                   k = nzb_diff_s_inner(j,i)-1
-                   tend(k,j,i) = tend(k,j,i) + g / pt(k,j,i) * shf(j,i)
-                ENDIF
-
-                IF ( use_top_fluxes )  THEN
-                   k = nzt
-                   tend(k,j,i) = tend(k,j,i) + g / pt(k,j,i) * tswst(j,i)
-                ENDIF
-
-             ENDDO
+             ELSE
+
+                DO  j = nys, nyn
+                   DO  k = nzb_diff_s_inner(j,i), nzt_diff
+                      tend(k,j,i) = tend(k,j,i) - kh(k,j,i) * g / pt(k,j,i) * &
+                                       ( pt(k+1,j,i) - pt(k-1,j,i) ) * dd2zu(k)
+                   ENDDO
+
+                   IF ( use_surface_fluxes )  THEN
+                      k = nzb_diff_s_inner(j,i)-1
+                      tend(k,j,i) = tend(k,j,i) + g / pt(k,j,i) * shf(j,i)
+                   ENDIF
+
+                   IF ( use_top_fluxes )  THEN
+                      k = nzt
+                      tend(k,j,i) = tend(k,j,i) + g / pt(k,j,i) * tswst(j,i)
+                   ENDIF
+                ENDDO
+
+             ENDIF
 
           ELSE
@@ -736,18 +758,39 @@
        IF ( .NOT. moisture )  THEN
 
-          DO  k = nzb_diff_s_inner(j,i), nzt_diff
-             tend(k,j,i) = tend(k,j,i) - kh(k,j,i) * g / pt(k,j,i) * &
-                                    ( pt(k+1,j,i) - pt(k-1,j,i) ) * dd2zu(k)
-          ENDDO
-
-          IF ( use_surface_fluxes )  THEN
-             k = nzb_diff_s_inner(j,i)-1
-             tend(k,j,i) = tend(k,j,i) + g / pt(k,j,i) * shf(j,i)
-          ENDIF
-
-          IF ( use_top_fluxes )  THEN
-             k = nzt
-             tend(k,j,i) = tend(k,j,i) + g / pt(k,j,i) * tswst(j,i)
-          ENDIF
+          IF ( use_pt_reference )  THEN
+
+             DO  k = nzb_diff_s_inner(j,i), nzt_diff
+                tend(k,j,i) = tend(k,j,i) - kh(k,j,i) * g / pt_reference * &
+                                       ( pt(k+1,j,i) - pt(k-1,j,i) ) * dd2zu(k)
+             ENDDO
+
+             IF ( use_surface_fluxes )  THEN
+                k = nzb_diff_s_inner(j,i)-1
+                tend(k,j,i) = tend(k,j,i) + g / pt_reference * shf(j,i)
+             ENDIF
+
+             IF ( use_top_fluxes )  THEN
+                k = nzt
+                tend(k,j,i) = tend(k,j,i) + g / pt_reference * tswst(j,i)
+             ENDIF
+
+          ELSE
+
+             DO  k = nzb_diff_s_inner(j,i), nzt_diff
+                tend(k,j,i) = tend(k,j,i) - kh(k,j,i) * g / pt(k,j,i) * &
+                                       ( pt(k+1,j,i) - pt(k-1,j,i) ) * dd2zu(k)
+             ENDDO
+
+             IF ( use_surface_fluxes )  THEN
+                k = nzb_diff_s_inner(j,i)-1
+                tend(k,j,i) = tend(k,j,i) + g / pt(k,j,i) * shf(j,i)
+             ENDIF
+
+             IF ( use_top_fluxes )  THEN
+                k = nzt
+                tend(k,j,i) = tend(k,j,i) + g / pt(k,j,i) * tswst(j,i)
+             ENDIF
+
+         ENDIF
 
        ELSE
Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 56)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 57)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! z0 removed from arguments in calls of diffusion_u/v/w
 !
 ! Former revisions:
@@ -130,8 +130,8 @@
           IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
              CALL diffusion_u( i, j, ddzu, ddzw, km_m, km_damp_y, tend, u_m,   &
-                               usws_m, v_m, w_m, z0 )
+                               usws_m, v_m, w_m )
           ELSE
              CALL diffusion_u( i, j, ddzu, ddzw, km, km_damp_y, tend, u, usws, &
-                               v, w, z0 )
+                               v, w )
           ENDIF
           CALL coriolis( i, j, 1 )
@@ -198,8 +198,8 @@
           IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
              CALL diffusion_v( i, j, ddzu, ddzw, km_m, km_damp_x, tend, u_m, &
-                               v_m, vsws_m, w_m, z0 )
+                               v_m, vsws_m, w_m )
           ELSE
              CALL diffusion_v( i, j, ddzu, ddzw, km, km_damp_x, tend, u, v,  &
-                               vsws, w, z0 )
+                               vsws, w )
           ENDIF
           CALL coriolis( i, j, 2 )
@@ -265,8 +265,8 @@
           IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
              CALL diffusion_w( i, j, ddzu, ddzw, km_m, km_damp_x, km_damp_y,  &
-                               tend, u_m, v_m, w_m, z0 )
+                               tend, u_m, v_m, w_m )
           ELSE
              CALL diffusion_w( i, j, ddzu, ddzw, km, km_damp_x, km_damp_y,    &
-                               tend, u, v, w, z0 )
+                               tend, u, v, w )
           ENDIF
           CALL coriolis( i, j, 3 )
@@ -668,8 +668,8 @@
              THEN
                 CALL diffusion_u( i, j, ddzu, ddzw, km_m, km_damp_y, tend,  &
-                                  u_m, usws_m, v_m, w_m, z0 )
+                                  u_m, usws_m, v_m, w_m )
              ELSE
                 CALL diffusion_u( i, j, ddzu, ddzw, km, km_damp_y, tend, u, &
-                                  usws, v, w, z0 )
+                                  usws, v, w )
              ENDIF
              CALL coriolis( i, j, 1 )
@@ -718,8 +718,8 @@
              THEN
                 CALL diffusion_v( i, j, ddzu, ddzw, km_m, km_damp_x, tend,     &
-                                  u_m, v_m, vsws_m, w_m, z0 )
+                                  u_m, v_m, vsws_m, w_m )
              ELSE
                 CALL diffusion_v( i, j, ddzu, ddzw, km, km_damp_x, tend, u, v, &
-                                  vsws, w, z0 )
+                                  vsws, w )
              ENDIF
              CALL coriolis( i, j, 2 )
@@ -767,8 +767,8 @@
              THEN
                 CALL diffusion_w( i, j, ddzu, ddzw, km_m, km_damp_x,          &
-                                  km_damp_y, tend, u_m, v_m, w_m, z0 )
+                                  km_damp_y, tend, u_m, v_m, w_m )
              ELSE
                 CALL diffusion_w( i, j, ddzu, ddzw, km, km_damp_x, km_damp_y, &
-                                  tend, u, v, w, z0 )
+                                  tend, u, v, w )
              ENDIF
              CALL coriolis( i, j, 3 )
@@ -1041,7 +1041,7 @@
     IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
        CALL diffusion_u( ddzu, ddzw, km_m, km_damp_y, tend, u_m, usws_m, v_m, &
-                         w_m, z0 )
+                         w_m )
     ELSE
-       CALL diffusion_u( ddzu, ddzw, km, km_damp_y, tend, u, usws, v, w, z0 )
+       CALL diffusion_u( ddzu, ddzw, km, km_damp_y, tend, u, usws, v, w )
     ENDIF
     CALL coriolis( 1 )
@@ -1113,7 +1113,7 @@
     IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
        CALL diffusion_v( ddzu, ddzw, km_m, km_damp_x, tend, u_m, v_m, vsws_m, &
-                         w_m, z0 )
+                         w_m )
     ELSE
-       CALL diffusion_v( ddzu, ddzw, km, km_damp_x, tend, u, v, vsws, w, z0 )
+       CALL diffusion_v( ddzu, ddzw, km, km_damp_x, tend, u, v, vsws, w )
     ENDIF
     CALL coriolis( 2 )
@@ -1184,8 +1184,7 @@
     IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
        CALL diffusion_w( ddzu, ddzw, km_m, km_damp_x, km_damp_y, tend, u_m, &
-                         v_m, w_m, z0 )
+                         v_m, w_m )
     ELSE
-       CALL diffusion_w( ddzu, ddzw, km, km_damp_x, km_damp_y, tend, u, v, w, &
-                         z0 )
+       CALL diffusion_w( ddzu, ddzw, km, km_damp_x, km_damp_y, tend, u, v, w )
     ENDIF
     CALL coriolis( 3 )
Index: palm/trunk/SOURCE/read_var_list.f90
===================================================================
--- palm/trunk/SOURCE/read_var_list.f90	(revision 56)
+++ palm/trunk/SOURCE/read_var_list.f90	(revision 57)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! +pt_reference
 !
 ! Former revisions:
@@ -252,4 +252,6 @@
           CASE ( 'pt_init' )
              READ ( 13 )  pt_init
+          CASE ( 'pt_reference' )
+             READ ( 13 )  pt_reference
           CASE ( 'pt_surface' )
              READ ( 13 )  pt_surface
Index: palm/trunk/SOURCE/user_interface.f90
===================================================================
--- palm/trunk/SOURCE/user_interface.f90	(revision 56)
+++ palm/trunk/SOURCE/user_interface.f90	(revision 57)
@@ -8,4 +8,5 @@
 ! routine user_statistics now has one argument (sr),
 ! sample for generating time series quantities added
+! Bugfix in sample for reading user defined data from restart file (user_init)
 !
 ! Former revisions:
@@ -174,4 +175,7 @@
 !
 !          END SELECT
+!
+!          READ ( 13 )  field_chr
+!
 !       ENDDO
 !    ENDIF
Index: palm/trunk/SOURCE/write_var_list.f90
===================================================================
--- palm/trunk/SOURCE/write_var_list.f90	(revision 56)
+++ palm/trunk/SOURCE/write_var_list.f90	(revision 57)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! +pt_refrence
 !
 ! Former revisions:
@@ -218,4 +218,6 @@
     WRITE ( 14 )  'pt_init                       '
     WRITE ( 14 )  pt_init
+    WRITE ( 14 )  'pt_reference                  '
+    WRITE ( 14 )  pt_reference
     WRITE ( 14 )  'pt_surface                    '
     WRITE ( 14 )  pt_surface
